*       Cteni parametru z INI souboru
*

*       Vraci   prvni nalezeny cIniParametr nebo pxDefault, pokud se nenalezl
*								parametr, sekce, nebo soubor
*
*       syntaxe INI souboru:
*       ; poznamkovy radek
*       * poznamkovy radek
*       [jmeno sekce]
*       klic-parametru [=] hodnota-parametru       ; poznamka
*       klic-parametru [=] hodnota-parametru       * poznamka

*       klic-parametru  nesmi obsahovat mezery nebo tabulatory, velka/mala pisemna jsou rovnocenna
*       hodnota-parametru       obsahuje-li ; nebo *  musi byt uzavrena v uvozovkach " "   ' '
*       zbytek radku vpravo od znaku poznamky (;*) se ignoruje


FUNCTION GetIniPar(pcIniFile, pcParName, pcSectName, pxDefault)
LOCAL xxReturnValue, xlSection, xcSection, xnLines, xcLine, xcR, xnPosS, xnPosR, xcKey, xcValue
LOCAL ARRAY xaLines(1)


#DEFINE mkComment       "*;"
#DEFINE mkStrBorder ["']
#DEFINE mkSectLeft  "["
#DEFINE mkSectRight "]"
#DEFINE CRLF	chr(13)+chr(10)


xxReturnValue=iif(PCount()=4, pxDefault, "")
if PCount() < 2             && neni zadan klic, neni co hledat
return xxReturnValue
endif
xlSection=(PCount() > 2)		&& je zadana sekce
xcSection=""
if xlSection
pcSectName=Upper(Alltrim(pcSectname))
endif
pcParName=Upper(Alltrim(pcParName))
pcIniFile=DefaultExt(pcIniFile, [ini])
IF .not.file(pcIniFile)			&& INIfile nenalezen, exit
	RETURN xxReturnValue
ENDIF
xnLines=ALines(xaLines, FileToStr(pcIniFile), .T.)

FOR each xcLine in xaLines

xcR=ChrTran(Alltrim(xcLine), chr(9), " ")       && tabulator -> space
if empty(xcR)
loop
endif

if left(xcR, 1) $ mkComment                   && poznamka, cist dalsi
loop
endif

xnPosS=at(" ", xcR)				&& posice 1. mezery nebo 0
xnPosR=at("=", xcR)				&& posice 1. rovnitka nebo 0
Do case
case (xnPosS > 0).and.(xnPosR > 0)
xnPos=min(xnPosS, xnPosR)                 && pozice 1. oddelovace
case (xnPosS = 0).and.(xnPosR > 0)
xnPos=xnPosR
case (xnPosS > 0).and.(xnPosR = 0)
xnPos=xnPosS
otherwise
xnPos=0
EndCase

xcKey=Upper(iif(xnPos > 0, left(xcR, xnPos-1), xcR))  && key (Par nebo Sect)
if (left(xcKey,1)==mkSectLeft).and.(right(xcKey,1)==mkSectRight)              && nalezena sekce
xcSection=substr(xcKey, 2, len(xcKey)-2)
loop
endif

if .not.(xcKey==pcParName)                      && klic <> param, cist dalsi
loop
endif

if xlSection
if .not.(xcSection==pcSectName)      && klic =, ale ruzna sekce
loop
endif
endif

	***     nalezen klic i sekce (je-li zadana)
xcValue=alltrim( right(xcR, len(xcR)-xnPos) )
xcValue=iif(left(xcValue,1)=="=", Ltrim(right(xcValue, len(xcValue)-1)), xcValue )
If left(xcValue,1) $ mkStrBorder               && uzavreno jako retezec?
xnPos=f_At(mkStrBorder, right(xcValue, len(xcValue)-1))    && ano, najdi pravy omezovac
If(xnPos > 0)                       && nalezen
xxReturnValue=substr(xcValue, 2, xnPos-1)
exit
endif
EndIf
xnPos=f_At(mkComment, xcValue)                && najdi comment, je-li
if xnPos > 0
xxReturnValue=Alltrim(left(xcValue, xnPos-1))
exit
endif
xxReturnValue=xcValue
exit

ENDFOR

RETURN xxReturnValue
